//=============================================================================
// MHWay
// A bot cannot be a human but human at least can do feign Bot ^^
//=============================================================================
class CTFWay expands KeyPoint;

//temporary beacon for server-find navigation
//And a lil loved
var float BestWeight;
var int j;
var bool bWorking;
//var float Time, F[2];
var Actor Path, OldPath, TheGoal;
var Vector HomeLocation, TmpHome;
var Rotator NewRot;
var TournamentPlayer P;
var Keypoint Kp[16];
var color clMsg;
var CTFFlag MyFlag, EnemyFlag;

function PostBeginPlay()
{
	HomeLocation=Location;
	bWorking=False;
	if (TournamentPlayer(Owner) != None)
		P = TournamentPlayer(Owner);
}

function CreateMyRoutes()
{
	if ( P != None )
	{
		Kp[0]=Self;
		Kp[1]=Spawn(Class'RCh1',P,,Location+vect(0,0,1));
		Kp[2]=Spawn(Class'RCh2',P,,Location+vect(0,0,2));
		Kp[3]=Spawn(Class'RCh3',P,,Location+vect(0,0,3));
		Kp[4]=Spawn(Class'RCh4',P,,Location+vect(0,0,4));
		Kp[5]=Spawn(Class'RCh5',P,,Location+vect(0,0,5));
		Kp[6]=Spawn(Class'RCh6',P,,Location+vect(0,0,6));
		Kp[7]=Spawn(Class'RCh7',P,,Location+vect(0,0,7));
		Kp[8]=Spawn(Class'RCh8',P,,Location+vect(0,0,8));
		Kp[9]=Spawn(Class'RCh9',P,,Location+vect(0,0,9));
		Kp[10]=Spawn(Class'RCh10',P,,Location+vect(0,0,10));
		Kp[11]=Spawn(Class'RCh11',P,,Location+vect(0,0,11));
		Kp[12]=Spawn(Class'RCh12',P,,Location+vect(0,0,12));
		Kp[13]=Spawn(Class'RCh13',P,,Location+vect(0,0,13));
		Kp[14]=Spawn(Class'RCh14',P,,Location+vect(0,0,14));
		Kp[15]=Spawn(Class'RCh15',P,,Location+vect(0,0,15));
	}
	DoHideThem();
}

function DoHideThem()
{
	local int i;

	for (i=1;i<16;i++)
	{
		if ( Kp[i] != None )
		{
			if (!Kp[i].bHidden )
				Kp[i].bHidden = True;
			Kp[i].SetOwner(Owner);
		}
	}
}

function Touch( Actor Other )
{
	//Nothing supposed to happen or do some coin zing-zang...
}

Event Destroyed()
{
	local int i;

	if ( P != None && !P.bDeleteMe ) //Usually UnSeen
		P.ClientMessage("CTFBeacon has expired...");
	for (i=1;i<16;i++)
	{
		if ( Kp[i] != None )
			Kp[i].Destroy();
	}
}

function DoSetChilds()
{
	local int i;

	for (i=1;i<16;i++)
	{
		if ( P.RouteCache[i] != None )
		{
			if (Kp[i] != None)
			{
				if ( Kp[i].bHidden )
						Kp[i].bHidden = False;
				if ( i < 15 )
					Kp[i].SetLocation(P.RouteCache[i].Location+vect(0,0,-30));
				else
					Kp[i].SetLocation(P.RouteCache[i].Location);
			}
		}
		else
		{
			if (Kp[i] != None)
			{
				if ( !Kp[i].bHidden )
					Kp[i].bHidden = True;
				TmpHome=HomeLocation;
				TmpHome.Z+=i;
				Kp[i].SetLocation(TmpHome);
			}
		}
	}
	if ( P.bHunting );
		P.bHunting=False;
}

function DoSayReach()
{
	if ( P != None )
	{
		if ( bWorking )
		{
			P.ClearProgressMessages();
			if ( !TheGoal.IsA('AltTarget') )
			{
				if ( EnemyFlag.Holder == None )
					P.SetProgressMessage("Destination is Reachable!",1);
				else
				{
					if ( EnemyFlag.Holder != P )
						P.SetProgressMessage("Cover Flag Carrier!",1);
					else
					{
						if ( MyFlag.bHome )
							P.SetProgressMessage("Run Home!",1);
						else
							P.SetProgressMessage("Try Recover Flag!",1);
					}
				}
			}
			else
				P.SetProgressMessage("TestBeacon is Reachable!",1);
			clMsg.R=255;
			clMsg.G=128;
			clMsg.B=0;
			P.SetProgressColor(clMsg,1);
			P.SetProgressTime(3);
			DoResetChilds();
//			NewRot = Rotator(P.Destination - P.Location);
//			P.ClientSetLocation(P.Location,NewRot);
//			bWorking=False;
		}
	}
}

function DoSayHereButNoReach()
{
	if ( P != None )
	{
		if ( bWorking )
		{
			P.ClearProgressMessages();
			P.SetProgressMessage("Destination is Visible but Not very Reachable!",1);
			clMsg.R=255;
			clMsg.G=128;
			clMsg.B=0;
			P.SetProgressColor(clMsg,1);
			P.SetProgressTime(3);
			DoResetChilds();
//			NewRot = Rotator(P.Destination - P.Location);
//			P.ClientSetLocation(P.Location,NewRot);
//			bWorking=False;
		}
	}
}

function DoResetChilds()
{
	local int i;

	bHidden=True;
	if ( Location != HomeLocation )
		SetLocation(HomeLocation);
	for (i=1;i<16;i++)
	{
		if ( P.RouteCache[i] != None )
			P.RouteCache[i] = None;
		if (Kp[i] != None)
		{
			if ( !Kp[i].bHidden )
				Kp[i].bHidden = True;
			TmpHome=HomeLocation;
			TmpHome.Z+=i;
			if ( Kp[i].Location != TmpHome )
				Kp[i].SetLocation(TmpHome);
		}
	}
}

function AcquireGoals()
{
	local CTFFlag TmpFlag;

	if ( P != None )
	{
		foreach AllActors ( class'CTFFlag', TmpFlag )
		{
			if ( TmpFlag.Team == P.PlayerReplicationInfo.Team )
			{
				MyFlag = TmpFlag;
				continue;
			}
			if ( TmpFlag.Team != P.PlayerReplicationInfo.Team )
			{
				EnemyFlag = TmpFlag;
				continue;
			}
		}
	}
}

function CheckGoal()
{
	if ( TheGoal.IsA('AltTarget') )
		return;

	if ( MyFlag != None && EnemyFlag != None )
	{
	
		if ( !MyFlag.bHome )
		{
			if ( TheGoal != MyFlag.Position() )
			{
				TheGoal = MyFlag.Position();
				P.ClearProgressMessages();
				P.SetProgressMessage("Team Flag is not in Base, switching routes... Recover Flag!",1);
				clMsg.R=255;
				clMsg.G=128;
				clMsg.B=0;
				P.SetProgressColor(clMsg,1);
				P.SetProgressTime(3);
			}
			return;
		}
		else
		{
			if ( EnemyFlag.Holder == P )
			{
				if ( TheGoal != MyFlag.Position() )
				{
					TheGoal = MyFlag.Position();
					P.ClearProgressMessages();
					P.SetProgressMessage("Switching routes to Base... Bring enemy Flag to Base!",1);
					clMsg.R=255;
					clMsg.G=128;
					clMsg.B=0;
					P.SetProgressColor(clMsg,1);
					P.SetProgressTime(3);
				}
				return;
			}
		}
		if ( TheGoal != EnemyFlag.Position() )
		{
			TheGoal = EnemyFlag.Position();
			P.ClearProgressMessages();
			if ( EnemyFlag.bHome )
				P.SetProgressMessage("Switching routes to Enemy Base... Take their Flag!",1);
			else
			{
				if ( EnemyFlag.Holder == None )
					P.SetProgressMessage("Switching routes to Enemy Flag... Finding their Flag!",1);
				else
					P.SetProgressMessage("Switching routes to Flag carrier... Cover your team carrier!",1);
			}
			clMsg.R=255;
			clMsg.G=128;
			clMsg.B=0;
			P.SetProgressColor(clMsg,1);
			P.SetProgressTime(3);
		}
	}
}


Auto State Tracking
{
Begin:
	Tag='CTFWay';
	Sleep (2.00);
	if ( P != None )
		CreateMyRoutes();
DoTesting:
	Path=None;
	if ( P == None || P.bDeleteMe )
	{
		Destroy(); Goto('End');
	}
	if ( bDeleteMe ) Goto('End');
	AcquireGoals();
	if ( bWorking && TheGoal != None && P != None )
	{
		CheckGoal();
		if ( P.Physics == Phys_Falling || P.Health < 1)
			Goto ('TimeCycling');
		if ( P.ActorReachable(TheGoal) )
		{
			DoSayReach();
//			bHidden=True;
			DoResetChilds();
			GoTo('TimeCycling');
		}
		else
		{
			if ( VSize(P.Location - TheGoal.Location) < 512 && FastTrace(P.Location,TheGoal.Location ))
			{
				DoSayHereButNoReach();
				GoTo('NoRouteCache');
			}
			Path=P.FindPathToward(TheGoal);
		}
		if ( Path != None )
		{
			SetLocation(Path.Location+vect(0,0,-30));
			bHidden = False;
			DoSetChilds();
			GoTo('TimeCycling');
		}
		else
		{
			P.bHunting=True;
			Path=P.FindPathToward(TheGoal);
		}
		if ( Path != None )
		{
			SetLocation(Path.Location+vect(0,0,-30));
			bHidden = False;
			DoSetChilds();
		}
		else
		{
NoRouteCache:
			DoResetChilds();
		}
	}
	if ( TheGoal == None )
		bWorking=False;
TimeCycling:
	if ( bWorking )
		Sleep(2.00);
	else
	{
		Sleep (1.5);
		if ( P != None )
			DoResetChilds();
		Sleep(1.5);
	}
	if ( !Level.Game.bGameEnded )
		GoTo('DoTesting');
	else
		GoToState('');
End:
}

defaultproperties
{
	bMovable=True
	Texture=Texture'RC0'
	Style=STY_Translucent
	ScaleGlow=0.5
	bUnlit=True
	bStatic=False
	bNoDelete=False
	bGameRelevant=True
	bOnlyOwnerSee=True
	bCollideActors=False
	DrawScale=0.500000
	CollisionRadius=1.000000
	CollisionHeight=1.000000
	NetUpdateFrequency=30.000000
	NetPriority=4.000000
	RemoteRole=ROLE_SimulatedProxy
	bStasis=False
}
