class RCh4 expands Keypoint;

var Vector HomeLocation;
var Actor Next;
var Rotator NewRot;

event PostBeginPlay()
{
	HomeLocation=Location;
}

final function GetNextOne()
{
	local KeyPoint K;

	foreach AllActors(class'Keypoint',K)
	{
		if ( K.IsA('RCh5') )
		{
			Next = K;
			break;
		}
	}
}

Auto State Guiding
{
Begin:
	Sleep(1.0);
		GetNextOne();
ALoop:
		if ( DrawType == DT_Mesh )
			DrawType = DT_Sprite;
		else
			DrawType = DT_Mesh;
	if ( Next != None )
	{
		if ( Next.Location != HomeLocation )
		{
			if ( DrawType == DT_Mesh )
			{
				Mesh=Mesh'RCBeacon';
				DrawScale = 0.5;
				NewRot = Rotator(Next.Location - Location);
				SetRotation(NewRot);
			}
			else
				DrawScale=1.000000;
		}
		else
		{
			if ( DrawType == DT_Mesh )
			{
				Mesh=Mesh'Lamp4M';
				DrawScale = 2;
			}
			else
				DrawScale = 1.000000;
		}
	}
	else
		GetNextOne();
LatentWait:
	Sleep(1.5);
		GoTo('ALoop');
}

defaultproperties
{
	bMovable=True
	bFixedRotationDir=True
	Style=STY_Translucent
	bUnlit=True
	ScaleGlow=0.500000
	Texture=Texture'RC4'
	DrawType=DT_Mesh
	Mesh=Mesh'RCBeacon'
	MultiSkins(0)=Texture'GenFluid.lava.Lava4'
	bGameRelevant=True
	bStatic=False
	bNoDelete=False
	bHidden=False
	bOnlyOwnerSee=True
	Tag=RTCH
	NetUpdateFrequency=10.000000
	NetPriority=3.000000
	bStasis=False
}
